# Roadmap

_Generated on 2025-05-30_

Found 820 TODO items in the codebase.

## BUG Items (6)

### CHANGELOG.html-S6aT0qVH.js

- **Line 15:** - fixes' > <span > Bug Fixes< / span > < / a > < / h3 > <ul > <li > ci issues. ( < a href = 'https://gitlab.acmecorp.com / Acme Corporationio / internal - projects / llm / acllm - components / commit / f9984c33fb6806a5542a42032e072050c1d5daf1' target = '_blank' rel = 'noopener noreferrer' > f9984c3`

### index.js

- **Line 12:** 1: Safari 10/11 doesn't reliably return the same Strings value.
- **Line 18:** 2: Safari 10/11 use the same cached strings value when the string parts are the same.

### dns.d.ts

- **Line 114:** in the name resolution service used by the operating system.

### agent.js

- **Line 212:** The session may be never created when:

### php-semantic-release.php

- **Line 165:** Fixes',

## FIXME Items (18)

### temp.js

- **Line 48:** Rough and quick attempt at detecting ok lengths
- **Line 51:** No truncable part detected, can't really do much without also changing the parent path, which is unsafe, hoping for the best here
- **Line 53:** The truncable part might be shorter than needed here

### temp.ts

- **Line 78:** This doesn't really always work, the actual filesystem limits must be detected for this to be implemented correctly

### built-in-definitions.js

- **Line 206:** Pure disabled to work around zloirock/core-js#262.

### ejs.js

- **Line 387:** Remove this in a future version
- **Line 746:** May end up with some false positives here

### referencer.js

- **Line 59:** Now, we don't create module environment, because the context is

### no-unmodified-loop-condition.js

- **Line 142:** This should probably be extracted to a function.

### jake.js

- **Line 237:** Should only need to add a new entry for the current

### rule.js

- **Line 79:** Right now this just throws away any passed-in args
- **Line 154:** Should allow optional ns passed in instead of this hack

### attemptify.js

- **Line 2:** The return type of these functions is wrong, it doesn't account for returning "undefined", but a correct type cannot be written because generics cannot be extended properly, it seems

### retryify.js

- **Line 4:** There are a boatload of anys here, but apparently generics cannot be extended properly, so...

### no-named-as-default.js

- **Line 49:** We can verify if a default and a named export are pointing to the same symbol only

### componentUtil.js

- **Line 70:** Remove try/catch when https://github.com/eslint/eslint-scope/issues/27 is implemented.

### dep-C6uTJdX2.js

- **Line 39865:** Should probably have an option in net.Socket to create a
- **Line 39873:** Hack to have stream not keep the event loop alive.

## HACK Items (8)

### minimatch.js

- **Line 590:** to work around lack of negative lookbehind in JS

### keys-of-union.d.ts

- **Line 41:** to fix https://github.com/sindresorhus/type-fest/issues/1008

### TimeZoneString.js

- **Line 35:** until LocalTZA, and "implementation-defined string" are available

### TimeZoneString.js

- **Line 38:** until DefaultTimeZone, IsTimeZoneOffsetString, ParseTimeZoneOffsetString, GetNamedTimeZoneOffsetNanoseconds, and "implementation-defined string" are available

### parse.js

- **Line 122:** espree blows up with frozen options

### stringifier.js

- **Line 141:** for first rule in CSS

### rollup-plugin-typescript2.cjs.js

- **Line 28207:** for rollup-plugin-vue, it creates virtual modules in form 'file.vue?rollup-plugin-vue=script.ts'

### dep-C6uTJdX2.js

- **Line 39843:** to have stream not keep the event loop alive.

## NOTE Items (412)

### index.d.ts

- **Line 25:** These definitions support NodeJS and TypeScript 4.9+.

### test.d.ts

- **Line 85:** **`shard` is used to horizontally parallelize test running across

### api.js

- **Line 32:** The v9.x version of this function doesn't have a cwd option

### flat-config-schema.js

- **Line 13:** This can be removed in ESLint v9 because structuredClone is available globally

### flat-eslint.js

- **Line 12:** Node.js 12 does not support fs/promises.

### letters.js

- **Line 3:** This file was generated using this script in JSCS based on the Unicode 7.0.0 standard: https://github.com/jscs-dev/node-jscs/blob/f5ed14427deb7e7aac84f3056a5aab2d9f3e563e/publish/helpers/generate-patterns.js

### eslint.config.js

- **Line 8:** Does not extend the standard .eslintrc.base.cjs due to flat config format,

### inline-callSuper-helpers.js

- **Line 43:** This doesn't work if this.__proto__.constructor has been modified.

### index.js

- **Line 11:** contrary to various Github issues, Edge 16+ *does* correctly infer the name of Arrow Functions.

### index-legacy.d.ts

- **Line 1:** This file is autogenerated. Do not modify.

### posix.js

- **Line 101:** This function doesn't automatically strip hash and query parts from
- **Line 116:** If you are working with file URLs,
- **Line 450:** that resolving these segments does not necessarily mean that all will be eliminated.
- **Line 464:** This function will remove the double slashes from a URL's scheme.
- **Line 1156:** the following properties:

### windows.js

- **Line 397:** The `URL` implementation guarantees that the drive letter and
- **Line 650:** that for normalize() to treat a path as an UNC path it needs to
- **Line 1167:** this will *probably* throw somewhere.

### index.js

- **Line 24:** The bind call isn't strictly required. But we need it for our mocks to work as expected.

### action.js

- **Line 69:** that the difference between the default and nargs=1 is that with the

### append.js

- **Line 23:** options.nargs should be optional for constants

### CoverageReporter.js

- **Line 370:** glob.sync is slow. By memoizing the files matching each glob

### index.js

- **Line 229:** that a possible improvement would be to analyse other information

### convert.js

- **Line 158:** this function may return an invalid dates for the regex tests

### create.js

- **Line 182:** The best we can do here is attempt to instance each sub type and apply through object assign. For non-object

### index.d.ts

- **Line 706:** the documentation says the ConfigAPI also exposes @babel/core's exports, but it actually doesn't
- **Line 756:** this is an undocumented reexport from "@babel/parser" but it's missing from its types

### index.d.ts

- **Line 445:** The current node path is included in this.
- **Line 488:** This is typically not a good idea to use. Building source strings when

### index.d.ts

- **Line 7:** This should only ever be done at the top-level application layer, in order to delay on

### index.d.ts

- **Line 365:** The default timeout interval is 5 seconds if this method is not called.
- **Line 371:** By default, jest.spyOn also calls the spied method. This is different behavior from most
- **Line 806:** that the type must be either an array or a tuple.
- **Line 1363:** `jest.fn(implementation)` is a shorthand for `jest.fn().mockImplementation(implementation)`.

### index.d.ts

- **Line 461:** the property name that the schema is testing will always be a string.

### net.d.ts

- **Line 48:** this will cause the streaming functionality to not provide any data, however events like 'error', 'end', and 'close' will

### experimental.d.ts

- **Line 59:** that SuspenseList require more than one child;

### index.d.ts

- **Line 1:** Users of the `experimental` builds of React should add a reference
- **Line 1405:** its presence prevents any of the deprecated lifecycle methods from being invoked
- **Line 1425:** the presence of this method prevents any of the deprecated
- **Line 1442:** the presence of [@link NewLifecycle.getSnapshotBeforeUpdate getSnapshotBeforeUpdate]
- **Line 1503:** You cannot call [@link Component.setState] here.
- **Line 1623:** String refs can be forwarded. We can't fix this bug without breaking a bunch of libraries now though.
- **Line 1855:** callbacks are _only_ allowed to return either void, or a destructor.
- **Line 1966:** without the ReducerState indirection, TypeScript would reduce S to be the most common
- **Line 1981:** that `useRef()` is useful for more than the `ref` attribute. It’s handy for keeping any mutable
- **Line 2040:** this does not accept strings, but this will have to be fixed by removing strings from type Ref<T>
- **Line 2075:** We don’t recommend adding debug values to every custom hook.

### index.d.ts

- **Line 159:** that when `void` is returned, the handler `argv` object type will not include command-specific arguments.
- **Line 405:** that any multi-char aliases (e.g. `help`) used for the help option will also be used for the implicit command.
- **Line 435:** that the OS locale can be modified by setting/exporting the `LC_ALL` environment variable.
- **Line 470:** that decimals, hexadecimals, and scientific notation are all accepted.
- **Line 514:** Providing a callback to parse() disables the `exitProcess` setting until after the callback is invoked.

### acorn.d.ts

- **Line 696:** that you are not allowed to call the

### acorn.js

- **Line 4459:** this updates `state.lastStringValue` property with the eaten name.

### argparse.js

- **Line 1201:** that the difference between the default and nargs=1 is that
- **Line 2259:** if add_mutually_exclusive_group ever gains title= and

### textwrap.js

- **Line 395:** that tabs and spaces are both treated as whitespace, but they

### async.js

- **Line 3214:** Since this function applies the `iteratee` to each item in parallel,
- **Line 3561:** if the async function errs, the result will not be cached and
- **Line 3692:** ** `parallel` is about kicking-off I/O tasks in parallel, not about

### helpers.js

- **Line 29:** If this is found to have issues, please also revist the logic in

### index.js

- **Line 497:** op_mob is not included as its chromium versions are not in sync with Opera desktop

### mbcs.js

- **Line 112:** This assumes that there are no 4-byte common chars.

### lexer.js

- **Line 1296:** non-asii BR and whitespace checks omitted for perf / footprint

### ejs.js

- **Line 378:** that the return type of the function also depends on the value of `opts.async`.

### index.js

- **Line 23:** I'm intentionally not DRYing up the other variables to keep them "lazy".

### referencer.js

- **Line 180:** Not referring variableScope. It is intended.
- **Line 498:** In ES6, ForStatement dynamically generates
- **Line 523:** This should be `variableScope`. Since direct eval call always creates Lexical environment and

### scope.js

- **Line 669:** Arrow functions never have an arguments objects.

### eslint.js

- **Line 29:** See

### api.js

- **Line 30:** The v8.x version of this function also accepted a `cwd` option, but

### cli-engine.js

- **Line 870:** The LintResultCache will remove the file source and any

### cli.js

- **Line 9:** The CLI object should *not* call process.exit() directly. It should only return

### config-loader.js

- **Line 211:** that we should not overuse queries (e.g., by appending the current time

### config.js

- **Line 569:** ruleOptions is always an array at this point because

### eslint.js

- **Line 649:** Linter does validation of the flags

### index.js

- **Line 238:** BOM already removed

### fork-context.js

- **Line 89:** `create` is just a wrapper that augments `new CodePathSegment`.

### rule-tester.js

- **Line 168:** This ignores `parent` property.

### capitalized-comments.js

- **Line 160:** that the comment itself need not be single-line!

### indent.js

- **Line 317:** that since collapsing only occurs when two tokens are on the same line, there are a few cases where non-intuitive

### no-setter-return.js

- **Line 233:** A previously declared function can be referenced and actually used as a setter in a property descriptor,

### no-useless-return.js

- **Line 310:** This event is notified for only reachable segments.

### prefer-object-spread.js

- **Line 115:** don't include the parens of the argument list.

### quotes.js

- **Line 47:** escaping of newlines when switching from backtick to other quotes is not handled.

### esprima.js

- **Line 6083:** replacing with '\uFFFF' enables false positives in unlikely

### iterate.js

- **Line 82:** this option does not exist on Node 18, but this is ok since the logic works without it. It just consumes more memory.

### common.js

- **Line 110:** that they are not supported in Glob itself anyway.

### utf16.js

- **Line 4:** UTF16-LE (or UCS2) codec is Node.js native. See encodings/internal.js

### extend-node.js

- **Line 3:** not polyfilled with safer-buffer on a purpose, as overrides Buffer
- **Line 12:** this does use older Buffer API on a purpose

### file-coverage.js

- **Line 293:** that the other object should have the same structure as this one (same file).

### annotator.js

- **Line 267:** order is important, since statements typically result in spanning the whole line and doing branches late

### rule.js

- **Line 60:** that, it is assumed a is a suffix of s.

### rule.jake.js

- **Line 49:** that tmp_dep2.o depends on tmp_dep2.c, which is a

### index.js

- **Line 371:** we might need to resolve this dir to an absolute path in the future

### index.js

- **Line 211:** that the data structures described above are conceptual only. The actual

### index.js

- **Line 412:** Intentionally NOT pushing/indexing into the array of mock

### resolver.js

- **Line 652:** once a moduleNameMapper matches the name, it must result

### index.js

- **Line 186:** that this only applies when they are required in an internal context;

### conversions.js

- **Line 5:** conversions should only return primitive values (i.e. arrays, or

### State.js

- **Line 207:** that this is only relevant when a snapshot is added and the dirty

### index.d.ts

- **Line 298:** this is different from ResourceLimits in that it checks at idle, after

### ChildProcessWorker.js

- **Line 121:** Detecting an out of memory crash is independent of idle memory usage monitoring. We want to

### js-yaml.js

- **Line 3216:** line breaking/folding is implemented for only the folded style.
- **Line 3236:** that this implies
- **Line 3277:** the special case: the string '\n' counts as a "trailing" empty line.
- **Line 3290:** a long line without a suitable break point will exceed the width limit.
- **Line 3333:** the match index will always be <= length-2.

### core.js

- **Line 4:** JS-YAML does not support schema-specific tag resolution restrictions.

### ky.d.ts

- **Line 119:** that response will be `undefined` in case `ky.stop` is returned.

### index.js

- **Line 25:** `~-` is the bitwise way to perform a `- 1` operation

### index.js

- **Line 88:** ** If `leading` and `trailing` options are `true`, `func` is

### index.js

- **Line 526:** ** The cache is exposed as the `cache` property on the memoized

### index.js

- **Line 1679:** ** This method is loosely based on
- **Line 1856:** ** Non-object values are coerced to objects.
- **Line 1889:** ** This method mutates `object`.

### minimatch.js

- **Line 906:** ending in / means that we'll get a final ""

### index.js

- **Line 37:** We cannot override the `name` property, as that is `readOnly`

### doc.d.ts

- **Line 204:** that, like cursorNodeStart, this is a misnomer and may actually be the text between two

### index.d.ts

- **Line 131:** that resolving these types is somewhat complicated, and it wasn't

### punycode.es6.js

- **Line 18:** U+007F DEL is excluded too.

### react-is.development.js

- **Line 56:** typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).

### _stream_readable.js

- **Line 107:** 0 is a valid value, means "don't call _read preemptively ever"
- **Line 396:** that this may be asynchronous, or synchronous.  Yes, it is

### _stream_writable.js

- **Line 106:** 0 is a valid value, means that we always return false if

### regenerate.js

- **Line 166:** the `- 1` makes `end` inclusive.
- **Line 203:** we cannot `return` just yet, in case any following pairs still
- **Line 365:** we cannot `return` just yet, as there may still be other
- **Line 376:** we cannot return yet.
- **Line 409:** we cannot `return` just yet.
- **Line 517:** the `\b` escape sequence for U+0008 BACKSPACE in strings has a
- **Line 523:** IE < 9 treats `'\v'` as `'v'`, so avoid using it.
- **Line 538:** `-` (U+002D HYPHEN-MINUS) is escaped in this way rather
- **Line 864:** the loop starts at the next index.
- **Line 1182:** `valueOf` is aliased as `toArray`.

### rewrite-pattern.js

- **Line 85:** `unicodeMatchPropertyValue` throws on invalid values.
- **Line 97:** `unicodeMatchProperty` throws on invalid properties.
- **Line 981:** `processTerm` mutates `tree` and `groups`.

### parser.js

- **Line 7:** The ECMA-262 standard uses the term "Assertion" for /^/. Here the
- **Line 148:** The following productions refer to the "set notation and
- **Line 213:** The following productions refer to the

### core.js

- **Line 29:** this must be require, not require.resolve, due to https://github.com/nodejs/node/issues/43274

### filter_sync.js

- **Line 10:** in v2.x, this will be `pkg, pkgfile, dir`, but must remain "broken" here in v1.x for compatibility

### constants.js

- **Line 3:** this is the semver.org version of the spec that it implements

### re.js

- **Line 116:** that the only major, minor, patch, and pre-release sections of
- **Line 139:** that "x.x" is a valid xRange identifer, meaning "any version"
- **Line 206:** that these all use the loose form, because they'll be

### index.d.ts

- **Line 58:** commands supplied in this way support a restricted set of characters

### response.d.ts

- **Line 336:** ignored files will not be added to the `files` array, and will not be included in the

### source-map.debug.js

- **Line 1381:** The order of the mappings is NOT guaranteed.

### jsonify.d.ts

- **Line 11:** The return value has to be `any` and not `unknown` so it can match `void`.

### type-detect.js

- **Line 125:** Most browsers currently adher to the W3C DOM Level 2 spec

### get.d.ts

- **Line 86:** This is needed to avoid being too lax with records types using number keys like `{0: string; 1: boolean}`.

### uri.all.js

- **Line 1178:** We do not parse query strings for HTTP URIs

### line.js

- **Line 4:** that startCol and endCol are absolute positions

### parser.js

- **Line 53:** May modify input array

### types.d.ts

- **Line 88:** this is required if nodeClass is not provided.

### index.js

- **Line 21:** Intentionally not using string interpolation for performance reasons.

### schemas.js

- **Line 786:** `Missing required key: "Key"`,

### eslint-recommended-raw.js

- **Line 2:** this file is isolated to be shared across legacy and flat configs.

### await-thenable.js

- **Line 97:** that this suggestion causes broken code for sync iterables

### no-unnecessary-condition.js

- **Line 50:** that this differs from [@link isNullableType] in that it doesn't consider

### prefer-nullish-coalescing.js

- **Line 522:** This does not imply that the nodes are runtime-equivalent.

### GlobalScope.js

- **Line 11:** this is accessed in used in the legacy eslint-scope tests, so it can't be true private

### ESLintScopeVariable.js

- **Line 16:** that this isn't a typo - ESlint uses this spelling here

### createProjectService.js

- **Line 120:** The inferred projects API is not intended for source files when a tsconfig

### useProgramFromProjectService.js

- **Line 166:** triggers a full project reload when changes are detected

### diff.js

- **Line 878:** that diff_commonPrefix and diff_commonSuffix are unicode-aware
- **Line 1040:** this runs after equality check has ruled out exact equality

### index.js

- **Line 60:** INSERT never advances the offset.

### simplify.d.ts

- **Line 6:** that it does *not* guarantee that it would match the same versions in all cases,

### eslint-recommended-raw.js

- **Line 2:** this file is isolated to be shared across legacy and flat configs

### consistent-type-exports.js

- **Line 87:** it is valid to export values as types. We will avoid reporting errors

### consistent-type-imports.js

- **Line 233:** - in TS 5.0 `experimentalDecorators` became the legacy option,

### indent.js

- **Line 3:** this file is rather type-unsafe in its current state.

### member-delimiter-style.js

- **Line 86:** can't have "none" for single line delimiter as it's invalid syntax
- **Line 91:** - need to define this last as it references the enums

### member-ordering.js

- **Line 653:** Not all members have names

### naming-convention.js

- **Line 10:** that that rule ignores leading and trailing underscores and only checks those in the middle of a variable name

### no-inferrable-types.js

- **Line 72:** that bigint cannot have + prefixed to it

### no-unnecessary-condition.js

- **Line 252:** It's also unnecessary if the types that don't overlap at all

### no-useless-template-literals.js

- **Line 136:** that some template literals get handled in the previous branch too.

### prefer-find.js

- **Line 211:** we're always looking for array member access to be "computed",

### compareNodes.js

- **Line 182:** - we purposely ignore optional flag because for our purposes

### collectUnusedVariables.js

- **Line 27:** - This is a simple visitor - meaning it does not support selectors

### getOperatorPrecedence.js

- **Line 15:** `Spread` is higher than `Comma` due to how it is parsed in |ElementList|
- **Line 27:** AssignmentExpression is broken down into several precedences due to the requirements
- **Line 40:** `Conditional` is considered higher than `Assignment` here, but in reality they have

### Referencer.js

- **Line 322:** In ES6, ForStatement dynamically generates per iteration environment. However, this is

### isUnsafeAssignment.js

- **Line 34:** in the case of generic positions, it makes the assumption that the two types are the same.

### typeFlagUtils.d.ts

- **Line 11:** that if the type is a union, this function will decompose it into the

### ast-spec.d.ts

- **Line 460:** that this is neither up to date nor fully correct.
- **Line 929:** that there may be 0 declarations (i.e. `const;`).

### convert.js

- **Line 1651:** - NewExpression cannot have an optional chain in it

### getScriptKind.js

- **Line 35:** - we only respect the user's jsx setting for unknown extensions

### index.js

- **Line 37:** - cannot migrate this to an import statement because it will make TSC copy the package.json to the dist folder

### node-utils.js

- **Line 629:** getWidth() does not take trivia into account.

### parser-options.d.ts

- **Line 49:** this setting does not effect known file types (.js, .cjs, .mjs, .jsx, .ts, .mts, .cts, .tsx, .json) because the
- **Line 139:** If `preserveNodeMaps` is explicitly set by the user, it will be respected,

### createParseSettings.js

- **Line 45:** - we intentionally use "unnecessary" `?.` here because in TS<5.3 this enum doesn't exist

### resolveProjectList.js

- **Line 50:** - we initialize the global cache based on the first config we encounter.

### LegacyESLint.d.ts

- **Line 23:** This option only applies when you pass directory paths to the eslint.lintFiles() method.

### RuleTester.d.ts

- **Line 58:** Suggestions will be applied as a stand-alone change, without triggering multi-pass fixes.

### IsWordChar.js

- **Line 21:** prior to ES2023, this AO erroneously omitted the latter of its arguments.

### InternalizeJSONProperty.js

- **Line 18:** `reviver` was implicitly closed-over until ES2020, where it becomes a third argument

### react-native.js

- **Line 8:** will not complain if only _one_ of these files exists.

### index.js

- **Line 38:** that this does not check explicitly re-exported names for existence

### consistent-type-specifier-style.js

- **Line 214:** - the default specifier *must* be the first specifier always!

### no-useless-path-segments.js

- **Line 73:** Using messageIds is not possible due to the support for ESLint 2 and 3

### accessors.js

- **Line 102:** that `value` here refers to the normalised value.

### convert.js

- **Line 1482:** - for compat with 3.7.x, where node.exportClause is always undefined and

### json-schema.js

- **Line 2:** - @types/json-schema@7.0.4 added some function declarations to the type package

### eslint-plugin-react-hooks.development.js

- **Line 503:** We could report here that the hook is not reachable, but
- **Line 688:** We could also support `ClassProperty` and `MethodDefinition`
- **Line 1156:** no need to handle OptionalMemberExpression because it can't be LHS.
- **Line 2218:** we don't check OptionalMemberExpression because it can't be LHS.
- **Line 2227:** If the node argument is an OptionalMemberExpression, it doesn't necessarily mean it is optional.

### jsx-child-element-spacing.js

- **Line 8:** 'br' is not included because whitespace around br tags is inconsequential to the rendered output

### no-adjacent-inline-elements.js

- **Line 52:** raw &nbsp; will be transformed into \u00a0.

### no-unescaped-entities.js

- **Line 18:** '<' and '{' are also problematic characters, but they do not need

### no-unknown-property.js

- **Line 402:** does not check if a tag's parent against a list of standard HTML/DOM tags. For example,
- **Line 431:** - these exclusions are not made by React core team, but `eslint-plugin-react` community.

### ast.js

- **Line 68:** will be undefined until we generate the regexp src and find out

### browser.js

- **Line 1242:** this does not detect the bug unless there's 20 characters

### react-is.development.js

- **Line 43:** its typeof might be other than 'symbol' or 'number' if it's a polyfill.

### index.d.ts

- **Line 2776:** It is intentional that this is not a type guard.
- **Line 2873:** that this is a shallow collection: it only returns `type.types` or `[type]`.

### index.d.ts

- **Line 214:** In extreme cases, this feature may result in some paths being

### index.js

- **Line 177:** that we use posix.join because:

### index.d.ts

- **Line 123:** this property is currently true by default but it will be changed to false in the next major version because Node's resolution

### index.d.ts

- **Line 132:** that restoring mock from `vi.fn()` will set implementation to an empty function that returns `undefined`. Restoring a `vi.fn(impl)` will restore implementation to `impl`.

### assertions.js

- **Line 225:** that `.all` is used by default when neither `.all` nor `.any` are
- **Line 374:** that a target object is always only searched for `val`'s own
- **Line 444:** that adding `.any` earlier in the chain causes the `.keys` assertion
- **Line 2307:** that `.all` is used by default when neither `.all` nor `.any` appear
- **Line 2985:** Duplicates are ignored if testing for inclusion instead of sameness.

### should.js

- **Line 27:** that we have to use [[DefineProperty]] instead of [[Put]]

### addChainableMethod.js

- **Line 30:** PhantomJS 1.x includes `callee` as one of `testFn`'s own properties,
- **Line 105:** that overwriting a chainable method merely replaces the saved

### addLengthGuard.js

- **Line 30:** that in ES6, the function's `length` property is configurable, so once

### main.d.ts

- **Line 685:** These declarations exist to avoid type errors when you omit "dom" from

### container.d.ts

- **Line 51:** that all containers can store any content. If you write a rule inside

### rollup-plugin-typescript2.cjs.js

- **Line 7293:** ** This function only supports comparing values with tags of
- **Line 7792:** ** This function only supports cloning values with tags of
- **Line 8240:** ** If this function becomes hot, i.e. is invoked a lot in a short
- **Line 8548:** ** Unlike `_.pullAll`, this method returns a new array.
- **Line 8576:** ** Unlike `_.pullAllBy`, this method returns a new array.
- **Line 8611:** ** Unlike `_.pullAllWith`, this method returns a new array.
- **Line 8793:** ** This method mutates `array`.
- **Line 9296:** ** Unlike `_.without`, this method mutates `array`. Use `_.remove`
- **Line 9319:** ** Unlike `_.difference`, this method mutates `array`.
- **Line 9347:** ** Unlike `_.differenceBy`, this method mutates `array`.
- **Line 9376:** ** Unlike `_.differenceWith`, this method mutates `array`.
- **Line 9404:** ** Unlike `_.at`, this method mutates `array`.
- **Line 9440:** ** Unlike `_.filter`, this method mutates `array`. Use `_.pull`
- **Line 9488:** ** This method mutates `array` and is based on
- **Line 9514:** ** This method is used instead of
- **Line 10136:** ** Unlike `_.pull`, this method returns a new array.
- **Line 10616:** ** This method mutates the wrapped array.
- **Line 10706:** ** This method returns `true` for
- **Line 10755:** ** Unlike `_.remove`, this method returns a new array.
- **Line 10935:** ** As with other "Collections" methods, objects with a "length"
- **Line 11686:** ** Unlike native `Function#bind`, this method doesn't set the "length"
- **Line 11787:** ** This method doesn't set the "length" property of curried functions.
- **Line 12297:** ** This method doesn't set the "length" property of partially
- **Line 12395:** ** This method is based on the
- **Line 12626:** ** This method is loosely based on the
- **Line 12748:** ** This method is equivalent to `_.conforms` when `source` is
- **Line 13127:** ** This method supports comparing arrays, array buffers, booleans,
- **Line 13223:** ** This method is based on
- **Line 13419:** ** This method is equivalent to `_.matches` when `source` is
- **Line 13522:** ** This method can't reliably detect native functions in the presence
- **Line 13600:** ** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
- **Line 14188:** ** This method mutates `object` and is loosely based on
- **Line 14901:** ** Non-object values are coerced to objects. See the
- **Line 15100:** ** This method is considerably slower than `_.pick`.
- **Line 15673:** ** JavaScript follows the IEEE-754 standard for resolving
- **Line 15847:** ** No other characters are escaped. To escape additional
- **Line 16078:** ** This method aligns with the
- **Line 16293:** ** In the development build `_.template` utilizes
- **Line 16759:** ** No other HTML entities are unescaped. To unescape additional
- **Line 16888:** ** This method doesn't set the "length" property of bound functions.
- **Line 16974:** ** The created function is equivalent to `_.conformsTo` with
- **Line 17164:** ** The created function is equivalent to `_.isMatch` with `source`
- **Line 17171:** ** Multiple values can be checked by combining several matchers
- **Line 17203:** ** Partial comparisons will match empty array and empty object
- **Line 17299:** ** Use `_.runInContext` to create a pristine `lodash` function to
- **Line 28100:** this does not need normalization as we only compare Rollup <-> Rollup, and not Rollup <-> TS
- **Line 28143:** that result.code is non-existent if emitDeclarationOnly per https://github.com/ezolenko/rollup-plugin-typescript2/issues/268

### rollup.d.ts

- **Line 128:** if plugins use new this.cache to opt-out auto transform cache

### loadConfigFile.js

- **Line 389:** that we do not have coverage for Windows-only code paths

### rollup.js

- **Line 6637:** this doesn't skip properties with defined getters/setters which we use to pack wrap booleans
- **Line 9618:** that class fields do not end up on the prototype
- **Line 14336:** that unknown test values are always included

### index.d.ts

- **Line 58:** ** When running code in Bun and Deno with Node.js compatibility mode, `isNode` flag will be also `true`, indicating running in a Node.js compatible runtime.

### index.js

- **Line 425:** This method does not do any warmup. Call {@link warmup} for that.

### index.d.ts

- **Line 1:** named reexports are used instead of `export *` because

### dep-C6uTJdX2.js

- **Line 5759:** this returns an actual array, not a generator, so it can be more
- **Line 5815:** if `undefined` is specified as a value, this is an alias for
- **Line 6853:** flushing CAN potentially switch us into not-flowing mode
- **Line 7636:** that fs operations that would normally throw will instead return an
- **Line 7992:** that we might know *something* about it if there has been a previous
- **Line 8137:** even on case-sensitive systems, it is **not** safe to test the
- **Line 8353:** that unlike `fs.lstat()`, the returned value does not contain some
- **Line 9175:** As of Node 19, this is very slow, compared to other methods of
- **Line 10526:** that a previous `Glob` object can be passed as the
- **Line 38462:** extra classes have been shaken out.
- **Line 38501:** no need to implement `kIsNodeError` symbol, would be hard,
- **Line 39836:** stream._type is used for test-module-load-list.js
- **Line 46982:** Skip keys that are accessed by esbuild and browser devtools.
- **Line 47106:** that individual package entries are allowed in ssr.external
- **Line 61691:** `options.ws` and `options.ssl` are optional.
- **Line 65974:** make sure rollup generate `module` params
- **Line 66076:** supports Node 6.x

### dep-CEGXe0Sr.js

- **Line 2738:** that this location is relative to the location of the first character

### dep-D-7KCb9p.js

- **Line 69:** excluding NULL and ASCII whitespace
- **Line 145:** HTML input preprocessing
- **Line 152:** Initial `lastGapPos` is -2, to ensure `col` on initialisation is 0
- **Line 163:** avoid reporting errors twice on advance/retreat
- **Line 196:** try to peek a surrogate pair
- **Line 200:** we have a surrogate pair. Peek pair character and recalculate code point.
- **Line 202:** add a gap that should be avoided during retreat
- **Line 207:** we are at the end of a chunk, therefore we can't infer the surrogate pair yet.
- **Line 212:** isolated surrogate
- **Line 271:** LF should be in the last column of the line
- **Line 282:** all U+000D CARRIAGE RETURN (CR) characters must be converted to U+000A LINE FEED (LF) characters
- **Line 288:** any U+000A LINE FEED (LF) characters that immediately follow a U+000D CARRIAGE RETURN (CR) character
- **Line 1157:** `offset` may never run across line boundaries.
- **Line 1371:** if we have a pending character token, make it's end location equal to the
- **Line 1437:** used when we emit characters explicitly.
- **Line 1463:** we don't flush all consumed code points here, and instead switch back to the original state after
- **Line 2822:** Doctypes tokens are created without fixed offsets. We keep track of the moment a doctype *might* start here.
- **Line 2837:** Sequence lookups can be abrupted by hibernation. In that case, lookup
- **Line 3201:** sequence lookup can be abrupted by hibernation. In that case lookup
- **Line 3731:** Matching can be abrupted by hibernation. In that case, match
- **Line 3994:** here we assume that the root <html> element is always first in the open element stack, so
- **Line 4215:** build attrs map for the new element, so we can perform fast lookups
- **Line 4218:** remove bottommost candidates, until Noah's Ark condition will not be met
- **Line 4894:** use a <template> element as the fragment context if no context element was provided,
- **Line 4897:** create a fake element which will be used as the `document` for fragment parsing.
- **Line 5110:** if we have a location assigned by another token, then just update the end position
- **Line 5131:** For cases like <p> <p> </p> - First 'p' closes without a closing
- **Line 5933:** store the next element for the next loop iteration (it may be deleted from the stack by step 9.5)
- **Line 6024:** Set end locations for elements that remain on the open element stack.
- **Line 6026:** If we are not in a fragment, `html` and `body` will stay on the stack.
- **Line 6418:** If the next token is a U+000A LINE FEED (LF) character token, then ignore that token and move
- **Line 6570:** here we assume that we always act as an user agent with enabled plugins, so we parse
- **Line 6854:** <body> is never popped from the stack, so we need to updated
- **Line 7775:** <html> is never popped from the stack, so we need to updated
- **Line 7930:** update the token tag name for `_setEndLocation`.

### index.d.ts

- **Line 686:** this downgrades to TLS only when the proxy option is also used.
- **Line 2373:** does not apply to library mode.
- **Line 3093:** User plugins are resolved before running this hook so injecting other

### index.d.ts

- **Line 58:** not very performant for complex types - this should only be used when you know you need it. If doing

### index.-xs08BYx.js

- **Line 4314:** not used in JUnitReporter

### index.ts

- **Line 7:** Logging, error handling, HTTP clients, and configuration are handled by Drupal

### index.d.ts

- **Line 105:** that [per RFC](https://httpwg.org/specs/rfc8246.html#the-immutable-cache-control-extension)

### events.d.ts

- **Line 39:** This class is in the docs but is **not actually exported** by Node.

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 5.7+.

### module.d.ts

- **Line 18:** the list doesn't contain prefix-only modules like `node:test`.

### readline.d.ts

- **Line 98:** According to the documentation:
- **Line 497:** we use the crlfDelay option to recognize all instances of CR LF

### web.d.ts

- **Line 347:** that the provided high water mark will not be validated ahead of

### test.d.ts

- **Line 84:** ** `shard` is used to horizontally parallelize test running across
- **Line 569:** ** Some of the functions from `node:assert` contain type assertions. If these are called via the
- **Line 706:** If a `wait` timeout is specified, it begins counting down only after the test function finishes executing.
- **Line 1499:** ** When you enable mocking for a specific timer, its associated
- **Line 1502:** ** Mocking `Date` will affect the behavior of the mocked timers
- **Line 1547:** This method will execute any mocked timers that are in the past from the new time.
- **Line 1569:** ** After each test completes, this function is called on
- **Line 1582:** ** This diverges from how `setTimeout` in Node.js behaves and accepts
- **Line 1686:** ** The `runAll()` function is specifically designed for

### tls.d.ts

- **Line 351:** `getSession()` works only for TLSv1.2 and below. For TLSv1.3, applications

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 4.9 through 5.6.

### util.d.ts

- **Line 1900:** that an effort will be made to coerce the given values into strings.

### v8.d.ts

- **Line 296:** that, when there are child classes inheriting from a constructor,

### vm.d.ts

- **Line 712:** This is a contrived example in that the linker function creates a new

### index.d.ts

- **Line 132:** ** Running `updateInterfaceInfo()` will trigger `clear()` only on network interface removal.

### parse.js

- **Line 39:** that `forceShell` is an hidden option used only in tests

### resolveCommand.js

- **Line 40:** that when a custom `cwd` was used, we need to resolve to an absolute path based on it

### form_data.js

- **Line 359:** getLengthSync DOESN'T calculate streams length

### types.d.ts

- **Line 331:** ** Only Got options are merged! Custom user options should be defined via [`options.context`](#context).

### client-request.js

- **Line 274:** that wrapping the raw stream in a Proxy instance won't improve the performance (already tested it).

### index.js

- **Line 253:** in IE 8, sometimes `global !== window` but both are the prototypes of each other

### index.d.ts

- **Line 268:** that typing information for null values is lost

### index.js

- **Line 1:** since nyc uses this module to output coverage, any lines

### lib.dom.d.ts

- **Line 1509:** that the provided high water mark will not be validated ahead of time. Instead, if it is negative, NaN, or not a number, the resulting ByteLengthQueuingStrategy will cause the corresponding stream constructor to throw.
- **Line 6806:** that script elements are not evaluated during parsing, and the resulting document's encoding will always be UTF-8.

### lib.es2015.generator.d.ts

- **Line 22:** 'next' is defined using a tuple to ensure we report the correct assignability errors in all places.

### lib.esnext.iterator.d.ts

- **Line 21:** This is specified as what is essentially an unreachable module. All actual global declarations can be found

### typescript.d.ts

- **Line 608:** Paths may also be directories.
- **Line 1425:** this us query-only operation and does not generate any output on disk.
- **Line 4502:** Consider calling `getEffectiveConstraintOfTypeParameter`
- **Line 5748:** that `@extends` is a synonym of `@augments`.
- **Line 5926:** that this field is only set by the module resolution process when
- **Line 6193:** that the resulting nodes cannot be checked.
- **Line 7964:** Transformation hooks should only be modified during `Transformer` initialization,
- **Line 8253:** Do not use this mode if you require accurate type errors; use [@link ParseForTypeErrors] instead.
- **Line 9267:** that the case of the config path has not yet been normalized, as no files have been imported into the project yet
- **Line 9586:** The file might not exist.
- **Line 9682:** that it is assumed that when asked about semantic diagnostics through this API,
- **Line 11327:** It is not allowed to call release on a SourceFile that was not acquired from

### typescript.js

- **Line 34692:** that theoretically the following condition would hold true literals like 009,
- **Line 60556:** cast to TransientSymbol should be safe because only TransientSymbols can have CheckFlags.SyntheticProperty
- **Line 149640:** that no attempt is made to take advantage of type argument inference
- **Line 166960:** there might be:
- **Line 178488:** that separators are part of the node in statements and class elements.
- **Line 178584:** after calling this, the TextChanges object must be discarded!
- **Line 190500:** that this does not return projects in info.containingProjects

## OPTIMIZE Items (8)

### model-training-pipeline.js

- **Line 219:** prompt templates
- **Line 291:** prompt templates based on analysis

### self-healing-orchestrator.js

- **Line 562:** test performance

### llmcliAutomationService.js

- **Line 122:** for project type
- **Line 170:** caching strategy based on project patterns
- **Line 315:** configuration based on project type

### create-logger.js

- **Line 91:** the hot-path which is the single object.

### logger.js

- **Line 224:** for the hotpath of logging JSON literals

## REVIEW Items (3)

### automated-mr-creator.js

- **Line 400:** guidance comment

### CONTRIBUTING.html--p1l4eRu.js

- **Line 49:** - process' > <span > Review Process< / span > < / a > < / h2 > <p > When submitting a merge request:< / p > <ol > <li > Explain the purpose and functionality of your component< / li > <li > Include documentation and examples< / li > <li > Reference any related issues< / li > <li > Ensure your changes pass CI / CD checks< / li > <li > Request review from at least one maintainer< / li > < / ol > <h2 id = 'versioning' tabindex = ' - 1' > <a class = 'header - anchor' href = '#versioning' > <span > Versioning< / span > < / a > < / h2 > <p > When making changes to existing components:< / p > <ul > <li > <strong > PATCH:< / strong> Bug fixes, documentation improvements< / li > <li > <strong > MINOR:< / strong> New features, non - breaking changes< / li > <li > <strong > MAJOR:< / strong> Breaking changes to inputs or behavior< / li > < / ul > <p > Update the <code > version< / code> field in the component metadata accordingly.< / p > < / div > `);

### typescript.js

- **Line 196089:** can optimize by coalescing simple edits

## TODO Items (352)

### openapi-test-generator.js

- **Line 670:** Implement test for [method] /path/to/resource
- **Line 675:** Implement error handling tests

### index.d.ts

- **Line 2:** item structure

### parser.js

- **Line 18:** message, /* TODO: message */, # TODO: message, <!-- TODO: message

### scanner.js

- **Line 34:** [llmcli] Add unit test for file scanning with various globs.
- **Line 35:** [llmcli] Add error handling for invalid globs.
- **Line 57:** [llmcli] Add error handling and logging for scanFiles

### api.js

- **Line 756:** Maybe move elsewhere? Maybe combine with getConfig() logic?
- **Line 814:** Maybe move elsewhere?

### typed.js

- **Line 128:** review removal octal = false
- **Line 183:** Review Removal octal = true;

### typescript.js

- **Line 25034:** : if there is inline sourceMap in jsFile, use that
- **Line 25037:** : if there is inline sourceMap in dtsFile, use that

### parser.test.ts

- **Line 6:** Refactor this function
- **Line 7:** [llmcli] Add OpenAPI contract test
- **Line 8:** [openapi] Validate schema

### scanner.test.ts

- **Line 8:** Adjust when fixtures are added

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

### corejs3-shipped-proposals.js

- **Line 1:** (Babel 8): remove this file now that it is included in babel-plugin-polyfill-corejs3

### plugin-bugfixes.js

- **Line 1:** (Babel 8): remove this file, in Babel 8 users import the .json directly

### core-js-compat.js

- **Line 1:** Remove in Babel 8

### normalize.js

- **Line 68:** Tree-based normalization of the ranges.

### index.ts

- **Line 244:** Implement remote config loading (Consul, etcd, etc.)
- **Line 279:** Implement config validation against schema

### loaders.ts

- **Line 254:** Implement etcd loader
- **Line 270:** Implement AWS Parameter Store loader
- **Line 283:** Handle certificate authentication
- **Line 286:** Handle IAM authentication
- **Line 374:** Validate merged config

### create-command.js

- **Line 193:** Implement command logic

### metrics-dashboard.js

- **Line 23:** SystemMonitor temporarily disabled due to build errors

### test-commands.ts

- **Line 206:** Add function documentation

### index.js

- **Line 692:** Throw more verbose error

### promise-polyfill.js

- **Line 4:** Remove this class once Node 22 becomes the minimum supported version.

### theme.js

- **Line 12:** use figure

### index.js

- **Line 158:** What to do if no results are found? Should we display a message?

### formatter.js

- **Line 10:** add [additonal formatters][1]

### legacyFakeTimers.js

- **Line 452:** Use performance.now() once it's mocked

### generateEmptyCoverage.js

- **Line 138:** consider passing AST

### constants.js

- **Line 3:** increment this version if there are schema changes

### ScriptTransformer.js

- **Line 824:** do we need to define the generics twice?

### index.js

- **Line 47:** cover with tests that configs from workspace .npmrc have bigger priority

### index.d.ts

- **Line 3780:** Move to react-dom

### index.d.ts

- **Line 4324:** Check impact of making React.ElementType<P = any> = React.JSXElementConstructor<P>

### index.d.ts

- **Line 202:** Remove the string ref special case from `PropsWithRef` once we remove LegacyRef
- **Line 522:** generalize this to everything in `keyof ReactHTML`, not just "input"
- **Line 1970:** double-check if this weird overload logic is necessary. It is possible it's either a bug
- **Line 2178:** change any to unknown when moving to TS v3
- **Line 4462:** It is SVGAnimateElement but is not in TypeScript's lib.dom.d.ts for now.
- **Line 4464:** It is SVGAnimateTransformElement but is not in TypeScript's lib.dom.d.ts for now.

### constants.js

- **Line 16:** Fetch the real limit from the filesystem //TODO: Fetch the whole-path length limit too
- **Line 17:** Fetch the real limit from the filesystem

### scheduler.js

- **Line 5:** Maybe publish this as a standalone package

### built-in-definitions.js

- **Line 337:** We should introduce overloaded instance methods definition
- **Line 360:** add async iterator dependencies when we support sub-dependencies

### index.d.ts

- **Line 1:** Make it this when TS suports that.

### index.js

- **Line 213:** Remove these aliases in the next major version

### utilities.js

- **Line 1:** When targeting Node.js 16, use `String.prototype.replaceAll`.

### iso2022.js

- **Line 35:** refactor me

### mbcs.js

- **Line 90:** Do we really need this?
- **Line 201:** This set of data comes from the character frequency-

### sbcs.js

- **Line 69:** 0x20 might not be a space in all character sets...
- **Line 79:** Is this OK? The buffer could have ended in the middle of a word...
- **Line 84:** - This is a bit of a hack to take care of a case

### unicode.js

- **Line 20:** Do some statistics to check for unsigned UTF-16BE
- **Line 41:** Do some statistics to check for unsigned UTF-16LE

### lexer.js

- **Line 196:** <!-- XML comment support

### string-utils.js

- **Line 3:** look at porting https://www.npmjs.com/package/wrap-ansi to ESM.

### index.js

- **Line 154:** maybe save() to a url target could be a PUT or something?

### compat.js

- **Line 28:** use `.flatMap` in core-js@4
- **Line 53:** Obsolete, remove from `core-js@4`

### targets-parser.js

- **Line 13:** Remove from `core-js@4`

### browser.js

- **Line 111:** add a `localStorage` variable to explicitly enable/disable colors

### index.js

- **Line 287:** Backslashes with no effect should not be escaped

### index.js

- **Line 249:** Use https://github.com/sindresorhus/safe-stringify when the package is more mature. Just copy-paste the code.

### referencer.js

- **Line 623:** ExportDeclaration doesn't exist. for bc?
- **Line 642:** `node.id` doesn't exist. for bc?

### eslint.js

- **Line 1017:** This is pretty dirty...would be nice to clean up at some point.

### index.js

- **Line 450:** We have a plan to remove this in a future major version.

### esquery.js

- **Line 209:** abstract into JSLanguage somehow

### linter.js

- **Line 991:** espree validate parserOptions.globalReturn when sourceType is setting to module.(@aladdin-add)
- **Line 1528:** Remove after flat config conversion
- **Line 2028:** Remove this check when we stop exporting the `SourceCode` object.

### capitalized-comments.js

- **Line 19:** Combine w/ max-len pattern?

### indent-legacy.js

- **Line 844:** - come up with a better strategy in future
- **Line 1234:** Add appropriate configuration options for variable

### no-warning-comments.js

- **Line 93:** something`
- **Line 105:** something ... `

### index.d.ts

- **Line 1186:** Remove in v10.0.0.

### token-translator.js

- **Line 108:** See if this is an Acorn bug

### index.d.ts

- **Line 97:** should be: extends Array<unknown> = [] */,

### common.js

- **Line 102:** is an absolute `cwd` supposed to be resolved against `root`?

### index.js

- **Line 15:** Remove the `.reduce` call.

### index.js

- **Line 246:** Make it return a web stream at some point.

### dbcs-codec.js

- **Line 348:** What if we have no default? (resCode == undefined)
- **Line 472:** Callback with seq.

### dbcs-data.js

- **Line 64:** KDDI extension to Shift_JIS
- **Line 65:** IBM CCSID 942 = CP932, but F0-F9 custom chars and other char changes.
- **Line 66:** IBM CCSID 943 = Shift_JIS = CP932 with original Shift_JIS lower 128 chars.

### extend-node.js

- **Line 169:** Set _charsWritten.

### report-base.js

- **Line 3:** switch to class private field when targetting node.js 12

### rule.js

- **Line 107:** Write a utility function that appends a

### sl.js

- **Line 111:** Should we keep the original `message`?

### index.js

- **Line 14:** Use private class fields when targeting Node.js 12.

### normalize.js

- **Line 592:** Type this properly

### index.js

- **Line 365:** check & read HasteFS instead of reading the filesystem:

### index.js

- **Line 28:** remove re-export in Jest 30
- **Line 32:** in Jest 30 remove `SpyInstance` in favour of `Spied`

### index.js

- **Line 171:** Get appropriate type for `onCustomMessage`

### index.js

- **Line 278:** make mandatory in Jest 30
- **Line 1187:** will this work on windows? It might be better if `shouldInstrument` deals with it anyways
- **Line 1861:** consider warning somehow that this does nothing. We should support deletions, anyways
- **Line 2031:** remove this check in Jest 30

### ChildProcessWorker.js

- **Line 246:** Add appropriate type check
- **Line 296:** At some point it would make sense to make use of

### js-yaml.js

- **Line 267:** Add tag format check.
- **Line 1755:** rework to inline fn with no type cast?

### merge.js

- **Line 35:** Make this strongly-typed (no `any`).

### minimatch.js

- **Line 491:** It would probably be faster to determine this

### doc.js

- **Line 1246:** Remove this in v4

### date.js

- **Line 43:** (special)

### action.js

- **Line 28:** create home() in prompt types (e.g. TextPrompt)
- **Line 30:** create end() in prompt types (e.g. TextPrompt)

### _stream_writable.js

- **Line 265:** defer error events consistently everywhere, not just the cb

### regenerate.js

- **Line 1141:** Optimize this by writing and using `dataIntersectionData()`.

### rewrite-pattern.js

- **Line 670:** consider changing this at the regenerate level.
- **Line 877:** remove modifiers: 'parse' in regexpu-core v7

### range.js

- **Line 489:** build?

### index.js

- **Line 44:** Remove the use of `.reduce` here.

### index.js

- **Line 72:** Use `/\p[RGI_Emoji]/v` when targeting Node.js 20.

### constants.js

- **Line 5:** Fetch the real limit from the filesystem, somehow

### init.js

- **Line 5:** see what's the best path for this

### arrayable.d.ts

- **Line 28:** Use `readonly T[]` when this issue is resolved: https://github.com/microsoft/TypeScript/issues/17002

### array.d.ts

- **Line 15:** should unknown-array be updated?

### subtract.d.ts

- **Line 36:** Support big integer.

### basic.d.ts

- **Line 3:** This can just be `export type Primitive = not object` when the `not` keyword is out.
- **Line 16:** Remove the `= unknown` sometime  in the future when most users are on TS 3.5 as it's now the default

### require-exactly-one.d.ts

- **Line 1:** Remove this when we target TypeScript >=3.5.

### update-notifier.js

- **Line 43:** Remove deprecated options at some point far into the future

### uri.all.js

- **Line 1013:** normalize IPv6 address as per RFC 5952

### v8-to-istanbul.js

- **Line 72:** investigate whether there's ever a case where we hit this logic with 1:many sources.
- **Line 252:** could we move the resolving logic for 1:1 source maps to the final

### logger.js

- **Line 49:** add class description.

### rejection-handler.js

- **Line 29:** add contructor description
- **Line 86:** add method description
- **Line 99:** (indexzero): how do we configure this?

### tail-file.js

- **Line 23:** add function description.

### file.js

- **Line 276:** Refactor me.
- **Line 518:** add method description.
- **Line 614:** What should we do with errors here?

### index.js

- **Line 11:** add property description.

### index.d.ts

- **Line 23:** remove this in the next major version, refactor the whole definition to:

### index.js

- **Line 46:** remove this in the next major version

### addPairToJSMap.js

- **Line 12:** Should drop this special case for bare << handling

### browser.js

- **Line 4:** figure out reasonable web equivalents for "resolve", "normalize", etc.

### index.js

- **Line 37:** figure  out a  way to combine ESM and CJS coverage, such  that

### index.js

- **Line 56:** Node.js 18.

### index.js

- **Line 4:** Use a better method when it's added to Node.js (https://github.com/nodejs/node/pull/40240)

### schemas.d.ts

- **Line 60:** unions?

### no-misused-promises.js

- **Line 481:** - Once we're able to use `checker.isTypeAssignableTo` (v8), we can check an index

### prefer-nullish-coalescing.js

- **Line 362:** also account for = in the ternary clause

### eslint-plugin-prettier.js

- **Line 63:** Only use property when our eslint peerDependency is >=8.40.0.

### eslint-recommended-raw.js

- **Line 26:** - remove this once we no longer support ESLint v8

### indent.js

- **Line 304:** This is invalid, there can be more than one extends in interface

### no-floating-promises.js

- **Line 91:** #5439

### no-inferrable-types.js

- **Line 128:** - if we add more references

### no-mixed-enums.js

- **Line 144:** We don't need to dip into the TypeScript type checker here!

### no-unnecessary-type-arguments.js

- **Line 68:** would like checker.areTypesEquivalent. https://github.com/Microsoft/TypeScript/issues/13502

### no-unnecessary-type-assertion.js

- **Line 256:** - add contextually unnecessary check for this

### no-unsafe-argument.js

- **Line 136:** - we could break down the spread and compare the array type against each argument
- **Line 174:** - handle generic iterable case

### no-unused-vars.js

- **Line 402:** ######

### analyzeChain.js

- **Line 169:** - we could further reduce the false-positive rate of this check by
- **Line 384:** - #7170

### compareNodes.js

- **Line 135:** - handle this once TS supports it (https://github.com/microsoft/TypeScript/issues/42734)

### strict-boolean-expressions.js

- **Line 572:** we have to compare to 0n if the type is bigint
- **Line 577:** don't suggest this for bigint because it can't be NaN

### getOperatorPrecedence.js

- **Line 123:** Do we need to investigate the precedence here?
- **Line 156:** JSXElement?

### getContextualType.js

- **Line 64:** - support return statement checking

### isUnsafeAssignment.js

- **Line 64:** - figure out how to handle cases like this,

### clear-caches.js

- **Line 24:** - delete this in next major

### convert.js

- **Line 1672:** do we really want to convert it to Token?

### createIsolatedProgram.js

- **Line 56:** Support Windows CRLF

### createProjectService.js

- **Line 19:** Once we drop support for TS<5.3 we can import from "typescript" directly
- **Line 21:** see getWatchProgramsForProjects

### getWatchProgramsForProjects.js

- **Line 200:** file issue on TypeScript to suggest making optional?
- **Line 257:** this needs refinement and development, but we're allowing users to opt-in to this for now for testing and feedback.

### RuleCreator.js

- **Line 13:** - when the above PR lands; add type checking for the context.report `data` property

### ESLint.js

- **Line 6:** - remove this in the next major

### SourceCode.d.ts

- **Line 269:** rename to 'tokens'

### implementation.js

- **Line 14:** use callBind.apply without breaking IE 8

### ArraySpeciesCreate.js

- **Line 29:** figure out how to make a cross-realm normal Array, a same-realm Array

### DetachArrayBuffer.js

- **Line 37:** see if this might trigger listeners

### GetIterator.js

- **Line 57:** This should return an IteratorRecord

### LengthOfArrayLike.js

- **Line 19:** use this all over

### ArrayBufferByteLength.js

- **Line 13:** support this
- **Line 25:** see if IsFixedLengthArrayBuffer can be used here in the spec instead

### IsTypedArrayOutOfBounds.js

- **Line 37:** probably use package for array length

### GetIntrinsic.js

- **Line 3:** remove, semver-major

### isStringOrHole.js

- **Line 3:** semver-major: remove

### async-generator-request-record.js

- **Line 10:** confirm is a completion record

### shim.js

- **Line 17:** install Symbol.toStringTag if needed, once https://bugs.chromium.org/p/chromium/issues/detail?id=1477372 is fixed?

### staticRequire.js

- **Line 2:** merge with module visitor

### index.js

- **Line 5:** restructure to key on path, value is resolver + map of names
- **Line 53:** report as unresolved?
- **Line 167:** keys, values, entries?

### specifier.js

- **Line 30:** JSDoc

### namespace.js

- **Line 108:** check for possible redefinition

### no-amd.js

- **Line 33:** capture define((require, module, exports) => {}) form?
- **Line 39:** check second arg type? (identifier or callback)

### prefer-todo.js

- **Line 26:** we should support this too (needs custom fixer)

### eslint-plugin-react-hooks.development.js

- **Line 1245:** we could potentially ignore early returns.
- **Line 1405:** also add an import?
- **Line 1406:** ideally we'd gather deps here but it would require
- **Line 1413:** What if the function needs to change on every render anyway?
- **Line 1418:** Why not report this at the dependency site?
- **Line 1709:** consider preserving the comments or formatting?
- **Line 1746:** Can this have a suggestion?

### index.js

- **Line 3:** this doesn't make sense for an ESLint rule.

### index.js

- **Line 34:** with TS 4.5+, inline this

### jsx-fragments.js

- **Line 71:** FIXME: can we fake these two descriptors?

### types.d.ts

- **Line 6:** fixme

### ast.js

- **Line 94:** properly warn on React.forwardRefs having typo properties

### linkComponents.js

- **Line 10:** type {(string | { name: string, linkAttribute: string })[]}
- **Line 15:** type {(string | { name: string, formAttribute: string })[]}

### functionsHaveNames.js

- **Line 5:** semver-major, remove

### index.d.ts

- **Line 2:** restrict this to require the brackets

### helper.js

- **Line 18:** update to babel 7

### getPropLiteralValue-flowparser-test.js

- **Line 350:** We should fix this to check to see if we can evaluate it.

### ast.js

- **Line 344:** instead of injecting the start/end at this point, just return

### implementation.js

- **Line 8:** replace with es-abstract 2024 implementation

### react-is.development.js

- **Line 27:** We don't use AsyncMode or ConcurrentMode anymore. They were temporary

### index.js

- **Line 1237:** handle type-only imports
- **Line 1354:** this actually references a parameter

### index.js

- **Line 353:** remove this in next major

### index.js

- **Line 405:** Drop if we do not support Node <= 16 anymore
- **Line 484:** We do not check if the key is a number here...
- **Line 1054:** set to false in next major release or remove

### sauce.browsers.js

- **Line 36:** fails because of Uint8Array support
- **Line 65:** These take forever to boot or shut down. Causes timeout.
- **Line 96:** fails because of error serialization

### magic-string.cjs.js

- **Line 131:** is this block necessary?...
- **Line 830:** last chunk in the array may not be the last chunk, if it's moved...
- **Line 1029:** deprecate this? not really very useful
- **Line 1310:** there's a bunch of this sort of thing, needs cleaning up

### rollup-plugin-typescript2.cjs.js

- **Line 28080:** use module resolution cache

### rollup.js

- **Line 19065:** we are pretending it was not found while it should behave like "undefined"

### watch.js

- **Line 139:** throws or warn? Currently just ignore, uses new event

### index.js

- **Line 36:** fallback to string parsing?

### dep-C6uTJdX2.js

- **Line 42697:** emit errors properly. Example: EMFILE on Macos.
- **Line 43321:** real check
- **Line 43810:** Strange thing: "should not choke on an ignored watch path" will be failed without 2 ready calls -__-
- **Line 43953:** this is not equal to path-normalize module - investigate why
- **Line 45024:** replace this whole reduce with a concat

### cli-api.OdDWuB7Y.js

- **Line 7773:** have a separate websocket conection for private browser API
- **Line 8190:** investigate further

### index.-xs08BYx.js

- **Line 4246:** v2.0.0 Remove env variable in favor of custom reporter options, e.g. "reporters: [['json', { classname: 'something' }]]"
- **Line 4330:** v2.0.0 Remove env variable in favor of custom reporter options, e.g. "reporters: [['json', { suiteName: 'something' }]]"

### index.js

- **Line 265:** Use `not ''` when the `not` operator is available.
- **Line 270:** Use `not` operator here to remove `Map` and `Set` from type guard:

### disposable.d.ts

- **Line 2:** remove once this package no longer supports TS 5.1, and replace with a

### indexable.d.ts

- **Line 2:** these methods are not used within @types/node, and should be removed at the next

### iterators.d.ts

- **Line 6:** remove once this package no longer supports TS 5.5, and replace NodeJS.BuiltinIteratorReturn with BuiltinIteratorReturn.

### promises.d.ts

- **Line 90:** Add `EventEmitter` close

### globals.d.ts

- **Line 254:** In next major @types/node version, change default TReturn to undefined.

### module.d.ts

- **Line 759:** consider removing in a future major version update

### net.d.ts

- **Line 46:** remove empty ConnectOpts placeholder at next major @types/node version.

### perf_hooks.d.ts

- **Line 99:** Narrow this based on entry type.

### test.d.ts

- **Line 2275:** change the export to a wrapper function once node@0db38f0 is merged (breaking change)

### timers.d.ts

- **Line 69:** remove in a future major version bump

### util.d.ts

- **Line 107:** , inspect: inspect

### wasi.d.ts

- **Line 159:** avoid DOM dependency until WASM moved to own lib.
- **Line 176:** Narrow to DOM types

### index.js

- **Line 56:** Remove this for the next major release

### index.js

- **Line 13:** Remove this when targeting Node.js 12.

### index.d.ts

- **Line 78:** Allow providing value type after https://github.com/Microsoft/TypeScript/issues/5413 is resolved.
- **Line 103:** Remove this for the next major release.

### form_data.js

- **Line 122:** Looks like there is bug in Node fs.createReadStream

### array-buffer.js

- **Line 64:** remove after dropping support for Node 20.
- **Line 66:** use `ArrayBuffer.transferToFixedLength()` instead once it is available

### index.js

- **Line 276:** Remove this when targeting Node.js >= 12
- **Line 313:** Move this to `_destroy()`
- **Line 377:** Deprecate URL options in Got 12.
- **Line 560:** remove this when `cacheable-request` supports async request functions.
- **Line 804:** Fix decompress-response
- **Line 1001:** Remove `utils/url-to-options.ts` when `cacheable-request` is fixed
- **Line 1004:** Fix this ignore.
- **Line 1010:** Fix `cacheable-response`
- **Line 1332:** What happens if it's from cache? Then this[kRequest] won't be defined.
- **Line 1379:** Remove the next `if` when these get fixed:

### get-buffer.js

- **Line 3:** Update https://github.com/sindresorhus/get-stream

### create.js

- **Line 91:** Remove this in Got 12.
- **Line 158:** Remove this `@ts-expect-error` when upgrading to TypeScript 4.
- **Line 176:** Throw when result is not an instance of Response

### index.js

- **Line 78:** Set this to `true` when Got 12 gets released

### index.js

- **Line 81:** When there is more than one value present for a given directive (e.g., two Expires header fields, multiple Cache-Control: max-age directives),

### agent.js

- **Line 163:** decreasing `maxFreeSessions` should close some sessions
- **Line 370:** Maybe the streams should have a "Session timed out" error?
- **Line 500:** Close last recently used (or least used?) session

### index.js

- **Line 1:** handle reviver/dehydrate function like normal

### index.js

- **Line 54:** use media-typer
- **Line 78:** should this even be in this module?
- **Line 91:** use content-type or other module

### index.d.ts

- **Line 34:** Remove this for the next major release, refactor the whole definition to:

### utils.js

- **Line 219:** RFC1738 format

### index.d.ts

- **Line 427:** Use the below instead when the following TS issues are fixed:

### typescript.js

- **Line 13781:** don't use slice
- **Line 19811:** Should prefix `++` and `--` be moved to the `Update` precedence?
- **Line 31393:** GH#18217
- **Line 32782:** should we separate these branches out?
- **Line 58754:** could probably serialize as function + ns + class, now that that's OK
- **Line 58844:** https://github.com/microsoft/TypeScript/pull/32372#discussion_r328386357
- **Line 134671:** syntax errors????
- **Line 156361:** Maybe we should handle this? See fourslash test `refactorConvertToEs6Module_export_object_shorthand.ts`.
- **Line 164589:** Handle auto quote preference.
- **Line 170969:** GH#23879
- **Line 174930:** should have its own kind?

### index.ts

- **Line 1177:** Add setup logic
- **Line 1201:** Implement test for [testCase.testMethod]

### DrupalAITestGenerator.ts

- **Line 1005:** Implement AI-generated test
- **Line 1079:** Implement AI-generated security test
- **Line 1104:** Implement AI-generated performance test

### index.ts

- **Line 172:** Add mock dependencies as constructor parameters
- **Line 186:** Add specific method tests following TDD red-green-refactor cycle
- **Line 208:** Test error conditions and edge cases
- **Line 216:** Test input validation logic
- **Line 258:** Add required modules
- **Line 269:** Add schema tables
- **Line 289:** Test that services are properly registered
- **Line 301:** Test module configuration
- **Line 376:** Add specific permissions
- **Line 380:** Add standard user permissions
- **Line 390:** Test admin pages
- **Line 405:** Test user workflows
- **Line 413:** Test anonymous user access patterns
- **Line 423:** Test form submissions
- **Line 464:** Test input validation for XSS, SQL injection, etc.
- **Line 474:** Test that malicious input is properly sanitized
- **Line 487:** Test access control mechanisms
- **Line 495:** Test CSRF token validation
- **Line 503:** Test sensitive data encryption/protection
- **Line 511:** Test authentication mechanisms
- **Line 561:** Add more fixture types
- **Line 580:** Add security assertion logic
- **Line 595:** Implement service mocking logic
- **Line 869:** Mock dependencies and create controller instance
- **Line 883:** Add method-specific tests
- **Line 932:** Test entity field validation logic
- **Line 940:** Test entity-specific business logic

## XXX Items (13)

### browser.js

- **Line 209:** (@Qix-) should we be logging these?

### common.js

- **Line 120:** Temporary. Will be removed in the next major release.
- **Line 280:** DO NOT USE. This is a temporary stub function.
- **Line 281:** It WILL be removed in the next major release.

### sync.js

- **Line 388:** review this.  Shouldn't it be doing the mounting etc

### inflight.js

- **Line 23:** It's somewhat ambiguous whether a new callback added in this

### minimatch.js

- **Line 859:** remove this slice.  Just pass the start index.

### preload.js

- **Line 3:** remove in v8 or beyond

### source-map.debug.js

- **Line 2155:** file:// URIs and absolute paths lead to unexpected behavior for

### ast.js

- **Line 483:** abstract out this map method

### dep-C6uTJdX2.js

- **Line 9632:** would be nice to handle patterns like `c:*` to test the cwd
- **Line 39828:** It's lame that node doesn't expose this API out-of-the-box. It also
- **Line 61446:** CHECK IF THIS IS THIS CORRECT

