# test-templates Component

GitLab CI/CD component for templates integration.

## Usage

```yaml
include:
  - component: gitlab.bluefly..io/bluefly/bfcicomponents/templates/test-templates@main

test_templates_job:
  extends: .test-templates
```

## Inputs

See the `template.yml` file for available inputs and their descriptions.

## Features

- Integration with GitLab CI/CD
- Standardized configuration
- Customizable options

## Requirements

- GitLab 17.0+ for component support
- Proper project structure and configuration

## License

MIT License - see LICENSE.md for details
