# Bug Report

## Description
<!-- Provide a clear and concise description of the bug -->

## Steps to Reproduce

1. <!-- First step -->
2. <!-- Second step -->
3. <!-- And so on... -->

## Expected Behavior
<!-- What did you expect to happen? -->

## Actual Behavior
<!-- What actually happened? Include screenshots if applicable -->

## Environment

- Component version: <!-- e.g., nodejs - base v1.0.0 -->
- GitLab CI / CD version: <!-- e.g., GitLab 15.4 -->
- Project type: <!-- e.g., Node.js app, React app, etc. -->
- CI / CD Runner: <!-- e.g., Docker, Shell, Custom, etc. -->

## Additional Context
<!-- Add any other context about the problem here. Include logs if available -->

## Possible Solution
<!-- If you have suggestions on a fix for the bug, please describe it here -->

/label ~bug ~needs - triage
