# LLM-MCP - MCP Protocol Server - Examples

This directory contains usage examples and tutorials for LLM-MCP - MCP Protocol Server.

## Available Examples

- [Basic Usage](./basic-usage.md) - Getting started with LLM-MCP - MCP Protocol Server
- [Advanced Configuration](./advanced-config.md) - Advanced setup and configuration
- [Integration Examples](./integration.md) - Integration with other services

## Running Examples

Follow the setup instructions in [../setup.md](../setup.md) first, then:

```bash
# Navigate to project directory
cd llm-mcp

# Run specific example
npm run example:basic  # or relevant command
```

## Contributing Examples

When adding new examples:

1. Create a new .md file with descriptive name
2. Include working code samples
3. Add setup instructions
4. Update this README with link to your example

---

*Part of the [LLM-MCP - MCP Protocol Server](../index.md) documentation.*
