---
id: usage
---
# TODOs for Usage

- [ ] Remove all hardcoded local paths from usage examples and scripts; use config or npm packages.
- [ ] Audit all usage examples for valid imports and dependency hygiene.
- [ ] Document and validate all configuration and environment variables used in examples.
- [ ] Add/expand usage tests and example-driven tests.
- [ ] Enforce OpenAPI validation for all usage-related endpoints.
- [ ] Integrate security and observability in all usage examples.
- [ ] Ensure usage examples are validated in CI/CD.
- [ ] Update usage documentation and add more real-world scenarios.

--- 
