---
id: modules-development-drupal_migration_plus-screenshots-README
---
# Screenshots

This directory contains screenshots of the Drupal Migration Plus module in action.

## Screenshot Organization

- `ui/`: Screenshots of the user interface
- `migrations/`: Screenshots of migration processes
- `results/`: Screenshots of migration results

## Adding Screenshots

When adding screenshots:

1. Use descriptive filenames: `migration-ui-source-selection.png`
2. Keep images at a reasonable size (max width: 1200px)
3. Use PNG format for interface screenshots
4. Add a brief description of each screenshot in this README

## Available Screenshots

(Add screenshots and descriptions here as they become available)

Example:
- `ui/migration-wizard-step1.png`: First step of the migration wizard showing source selection
