# BFRFP - AI Content Generation - Integration Guide

This directory contains integration documentation for BFRFP - AI Content Generation.

## Integration Types

### Internal Services

- No internal service dependencies

### External Services

- [Third-party APIs](./external/apis.md)
- [Webhooks](./external/webhooks.md)
- [Authentication](./external/auth.md)

### Platform Integration

- [Drupal Integration](./platform/drupal.md)
- [GitLab CI/CD](./platform/gitlab.md)
- [Kubernetes](./platform/kubernetes.md)

## Integration Patterns

- [Event-driven Integration](./patterns/events.md)
- [API-first Integration](./patterns/api.md)
- [Data Synchronization](./patterns/sync.md)

---

*Part of the [BFRFP - AI Content Generation](../index.md) documentation.*
