# Examples

> Note: This document replaces a symlink that previously pointed to `./llm-mcp/docs/examples/examples.md` which doesn't exist.

For examples of how to use the Model Control Plane, please refer to the examples directory in the repository.

## Basic Usage

```javascript
import [ModelControlPlane] from '@bluefly/mcp';

const mcp = new ModelControlPlane({
  provider: 'anthropic',
  apiKey: process.env.ANTHROPIC_API_KEY
});

const result = await mcp.generateText({
  prompt: 'Explain quantum computing in simple terms',
  maxTokens: 100
});

console.log(result);
```

See the examples directory for more detailed examples.