# Guides

This directory contains guides for using and configuring llm-mcp.

## Available Documentation

- [Getting Started Guide](./getting-started.md) - Comprehensive step-by-step guide for new users
- [Tool Registration Guide](./tool-registration.md) - Detailed guide for registering and using tools
- [Vector Operations Guide](./vector-operations.md) - Detailed guide for vector storage and retrieval
- [Setup Guide](../setup.md) - Detailed guide for setting up llm-mcp
- [Configuration Guide](../configuration.md) - Guide for configuring llm-mcp
- [Cursor Directory Integration](../cursor-directory-integration.md) - Guide for integrating with Cursor Directory
