# secure_project Documentation

## Overview

This directory contains documentation for the secure_project project.

## Available Documentation

- [Adapter Events and Extensions](./adapter-events-extensions.md)
- [Adapter Plugins](./adapter-plugins.md)
- [Adapter Plugins Refactoring](./ADAPTERS-REFACTORING.md)
- [Drupal Integration Guide](./drupal-integration.md)
- [Plugin Authoring & Usage Guide](./plugin-usage.md)
- [Secure Project - Enterprise Security and Audit Library](./README.md)
- [Secure Drupal Restructuring - Progress Report](./RESTRUCTURING_PROGRESS_REPORT.md)
- [Secure Drupal Module Restructuring Summary](./RESTRUCTURING_SUMMARY.md)
- [Secure Compliance Suite Plugin System Implementation](./SECURE_COMPLIANCE_PLUGIN_SYSTEM.md)
- [Secure Drupal Module File Mapping](./SECURE_DRUPAL_FILE_MAPPING.md)
- [Secure Drupal Module Restructuring - Implementation Roadmap](./SECURE_DRUPAL_IMPLEMENTATION_ROADMAP.md)
- [Secure Drupal Restructuring Implementation Guide](./SECURE_DRUPAL_RESTRUCTURING_IMPLEMENTATION_GUIDE.md)
- [Secure Drupal Module Restructuring Plan](./SECURE_DRUPAL_RESTRUCTURING_PLAN.md)
- [Secure Project Integration](./SECURE_PROJECT_INTEGRATION.md)
- [TDD Coverage Roadmap](./TDD-COVERAGE-ROADMAP.md)
- [TDD Implementation Summary](./TDD-IMPLEMENTATION-SUMMARY.md)
- [TDD Task Tracking for Secure Project](./TDD-TASK-TRACKING.md)
