module.exports = {
  'Secure Drupal recipe dashboard and config pages load': function (browser) {
    const pages = [
      { path: '/admin/recipes/secure-drupal', title: 'Secure Drupal Recipes' },
      { path: '/admin/recipes/secure-drupal/config', title: 'Secure Drupal Configuration' }
    ];
    browser.loginAsAdmin();
    pages.forEach(page => {
      browser
        .url(browser.launchUrl + page.path)
        .waitForElementVisible('body', 2000)
        .assert.containsText('body', page.title);
    });
    browser.logout();
  }
}; 