---
id: secure_drupal-README
---
# Secure Drupal Documentation

This directory contains documentation for the Secure Drupal module.

## Contents

- [Integration Guide](integration) - How to integrate with the Secure Drupal module
- [API Documentation](api) - API reference for the Secure Drupal module
- [Architecture](architecture) - Architectural overview of the Secure Drupal module
- [Configuration](configuration) - Configuration options and best practices

## Related Documentation

- [Integration Patterns](../integration/patterns)
- [Integration Code Quality](../integration/code-quality)
- [Service Naming Conventions](../integration/service-naming-conventions)
