module.exports = {
  testEnvironment: 'node',
  testMatch: [
    '**/__tests__/**/*.test.[jt]s?(x)',
    '**/__tests__/**/*.[jt]s?(x)',
    '!**/__tests__/fixtures/**',
    '!**/__tests__/helpers/**'
  ],
  collectCoverageFrom: [
    'src/**/*.[jt]s?(x)',
    '!src/**/*.d.ts',
    '!src/**/*.test.[jt]s?(x)'
  ],
  transform: {
    '^.+\\.(ts|tsx)$': 'ts-jest'
  }
};
